## axe-demultiplexer 0.3.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT(axe C)

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake-modules")

# Cmake options
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
ENABLE_TESTING()

IF (NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release)
ENDIF()

IF (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/version")
	FILE(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/version" AXE_VERSION)
ELSE()
	# git describe as versioning
	EXECUTE_PROCESS(COMMAND git describe
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE AXE_VERSION
			OUTPUT_STRIP_TRAILING_WHITESPACE)
ENDIF()

MESSAGE(STATUS "${CMAKE_BUILD_TYPE} build of axe version: ${AXE_VERSION}")

###############################
## Find Packages and Headers ##
###############################

FIND_PACKAGE(ZLIB 1.2.5 REQUIRED)

FIND_PACKAGE(GSL)

IF (GSL_FOUND)
    SET(AXE_DEP_INCLUDES ${GSL_INCLUDE_DIRS})
    SET(AXE_DEP_LIBS ${GSL_LIBRARIES})
ENDIF()


##########################
## Set Compiler Options ##
##########################

IF (CMAKE_COMPILER_IS_GNUCC)
        SET(AXEWRN "${AXEWRN} -Woverride-init -Wnormalized=id -Wlogical-op")
        EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                        OUTPUT_VARIABLE GCC_VERSION)
        IF (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
                SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fdiagnostics-color=always")
        ENDIF()
ENDIF()

# Set CFLAGS
SET(AXEWRN "${AXEWRN} -fstack-protector-all -Wstack-protector -Wfloat-equal")
SET(AXEWRN "${AXEWRN} -Wundef -Wpointer-arith -Wstrict-prototypes")
SET(AXEWRN "${AXEWRN} -Wmissing-prototypes -Wwrite-strings -Wredundant-decls")
SET(AXEWRN "${AXEWRN} -Wchar-subscripts -Wcomment -Wformat=2 -Wwrite-strings")
SET(AXEWRN "${AXEWRN} -Wmissing-declarations -Wredundant-decls -Wnested-externs")
SET(AXEWRN "${AXEWRN} -Wbad-function-cast -Wswitch-enum -Winit-self")
SET(AXEWRN "${AXEWRN} -Wmissing-field-initializers -Wdeclaration-after-statement")
SET(AXEWRN "${AXEWRN} -Wold-style-definition -Waddress -Wmissing-noreturn ")
SET(AXEWRN "${AXEWRN} -Wstrict-overflow=1 -Wextra -Warray-bounds -Wall -D_FORTIFY_SOURCE=2")

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${AXEWRN}")

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src
                    ${CMAKE_SOURCE_DIR}/src/datrie
                    ${CMAKE_SOURCE_DIR}/src/libqes/src
                    ${CMAKE_SOURCE_DIR}/src/gsl)
LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lib)

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/src/axe_config.h.in
               ${CMAKE_BINARY_DIR}/axe_config.h)

ADD_SUBDIRECTORY(docs)
ADD_SUBDIRECTORY(tests)
ADD_SUBDIRECTORY(src)
SET(LIBQES_AS_SUBMODULE True)  # stop libqes installing itself
ADD_SUBDIRECTORY(src/libqes)

=== docs/CMakeLists.txt ===
FIND_PROGRAM(SPHINXBUILD sphinx-build)
IF(SPHINXBUILD)
    SET(ALLSPHINXOPTS -q -D latex_paper_size=a4)
    ADD_CUSTOM_TARGET(doc_html
        COMMAND ${SPHINXBUILD} -b html ${ALLSPHINXOPTS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_BINARY_DIR}/doc/html
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc_onehtml
        COMMAND ${SPHINXBUILD} -b singlehtml ${ALLSPHINXOPTS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_BINARY_DIR}/doc/single
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc_man
        COMMAND ${SPHINXBUILD} -b man ${ALLSPHINXOPTS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_BINARY_DIR}/doc/man
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc_clean
	COMMAND ${CMAKE_COMMAND} -E remove_directory "${CMAKE_BINARY_DIR}/doc"
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    ADD_CUSTOM_TARGET(doc ALL DEPENDS doc_man doc_onehtml)
    INSTALL(FILES ${CMAKE_BINARY_DIR}/doc/man/axe.1 DESTINATION "share/man/man1" RENAME "axe-demux.1")
    SET_DIRECTORY_PROPERTIES(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES doc/)
ELSE()
    MESSAGE(WARNING "Cannot build documenation, sphinx isn't installed")
ENDIF()

=== tests/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/tinytest)

ADD_EXECUTABLE(test_axe test.c ${CMAKE_CURRENT_SOURCE_DIR}/tinytest/tinytest.c test_libaxe.c)
TARGET_LINK_LIBRARIES(test_axe ${AXE_DEPENDS_LIBRARIES} axelib)

# Copy test files over to bin dir & make output
ADD_CUSTOM_TARGET(setup_tests ALL
	COMMAND ${CMAKE_COMMAND} -E copy_directory
		   ${CMAKE_CURRENT_SOURCE_DIR}/data
                   ${CMAKE_BINARY_DIR}/data
	COMMAND ${CMAKE_COMMAND} -E copy
                   ${CMAKE_CURRENT_SOURCE_DIR}/axe_cli_tests.py
                   ${CMAKE_BINARY_DIR}/bin
	COMMAND ${CMAKE_COMMAND} -E make_directory
                   ${CMAKE_BINARY_DIR}/out)
ADD_DEPENDENCIES(test_axe setup_tests)

ADD_TEST(NAME "UnitTests" COMMAND test_axe)
SET(COVERAGE_CMD test_axe)
SET(COVERAGE_OUT "${CMAKE_BINARY_DIR}/coverage_html")

ADD_TEST(NAME "IntegrationTests" COMMAND python
         ${CMAKE_BINARY_DIR}/bin/axe_cli_tests.py
         ${CMAKE_BINARY_DIR})

IF (CMAKE_BUILD_TYPE STREQUAL "Coverage")
	FIND_PROGRAM( GCOV_PATH gcov )
	FIND_PROGRAM( LCOV_PATH lcov )
	FIND_PROGRAM( GENHTML_PATH genhtml )
	FIND_PROGRAM( GCOVR_PATH gcovr PATHS ${CMAKE_SOURCE_DIR}/tests)

	SET(CMAKE_C_FLAGS_COVERAGE
	    "${CMAKE_C_FLAGS_DEBUG} -g -O0 --coverage -fprofile-arcs -ftest-coverage"
	    CACHE STRING "Flags used by the C compiler during coverage builds."
	    FORCE)
	SET(CMAKE_EXE_LINKER_FLAGS_COVERAGE
	    ""
	    CACHE STRING "Flags used for linking binaries during coverage builds."
	    FORCE)
	SET(CMAKE_SHARED_LINKER_FLAGS_COVERAGE
	    ""
	    CACHE STRING "Flags used by the shared libraries linker during coverage builds."
	    FORCE)
	MARK_AS_ADVANCED(
	    CMAKE_C_FLAGS_COVERAGE
	    CMAKE_EXE_LINKER_FLAGS_COVERAGE
	    CMAKE_SHARED_LINKER_FLAGS_COVERAGE )

	IF(NOT GCOV_PATH)
		MESSAGE(FATAL_ERROR "gcov not found! Aborting...")
	ENDIF() # NOT GCOV_PATH
	IF(NOT LCOV_PATH)
		MESSAGE(FATAL_ERROR "lcov not found! Aborting...")
	ENDIF() # NOT LCOV_PATH
	IF(NOT GENHTML_PATH)
		MESSAGE(FATAL_ERROR "genhtml not found! Aborting...")
	ENDIF() # NOT GENHTML_PATH
	IF(NOT CMAKE_COMPILER_IS_GNUCC AND NOT CMAKE_COMPILER_IS_GNUCXX)
		# Clang version 3.0.0 and greater now supports gcov as well.
		MESSAGE(WARNING "Compiler is not GNU gcc! Clang Version 3.0.0 and greater supports gcov as well, but older versions don't.")
		IF(NOT "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" AND NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
			MESSAGE(FATAL_ERROR "Compiler is not GNU gcc! Aborting...")
		ENDIF()
	ENDIF() # NOT CMAKE_COMPILER_IS_GNUCXX

	# Setup target
	ADD_CUSTOM_TARGET(coverage
		# Cleanup lcov
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --directory  ${CMAKE_BINARY_DIR}/src --zerocounters

		# Run tests
		COMMAND ${COVERAGE_CMD}

		# Capturing lcov counters and generating report
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --directory ${CMAKE_BINARY_DIR}/src --capture --output-file ${COVERAGE_OUT}.info
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --output-file ${COVERAGE_OUT}.info --remove ${COVERAGE_OUT}.info src/kmlib/*
		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --output-file ${COVERAGE_OUT}.info --remove ${COVERAGE_OUT}.info src/datrie/*
		COMMAND ${GENHTML_PATH} --branch-coverage -o ${COVERAGE_OUT} ${COVERAGE_OUT}.info
		COMMAND ${CMAKE_COMMAND} -E remove ${COVERAGE_OUT}.info

		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Resetting code coverage counters to zero.\nProcessing code coverage counters and generating report."
	)

	# Show info where to find the report
	ADD_CUSTOM_COMMAND(TARGET coverage POST_BUILD
		COMMAND ;
		COMMENT "Open ${COVERAGE_OUT}/index.html in your browser to view the coverage report."
	)

ENDIF() # build type coverage

=== tests/tinytest/Makefile ===
VERSION=1.0.1

all: tt-demo

.c.o:
	gcc -Wall -g -O2 -c $<

tinytest.o: tinytest.h

tinytest_demo.o: tinytest_macros.h tinytest.h

OBJS=tinytest.o tinytest_demo.o

tt-demo: $(OBJS)
	gcc -Wall -g -O2 $(OBJS) -o tt-demo

lines:
	wc -l tinytest.c tinytest_macros.h tinytest.h

clean:
	rm -f *.o *~ tt-demo

DISTFILES=tinytest.c tinytest_demo.c tinytest.h tinytest_macros.h Makefile \
	README

dist:
	rm -rf tinytest-$(VERSION)
	mkdir tinytest-$(VERSION)
	cp $(DISTFILES) tinytest-$(VERSION)
	tar cf - tinytest-$(VERSION) | gzip -c -9 > tinytest-$(VERSION).tar.gz

=== debian/changelog ===
axe-demultiplexer (0.3.1-3) unstable; urgency=medium

  * Syntax fix for autopkgtest

 -- Kevin Murray <spam@kdmurray.id.au>  Sat, 06 Feb 2016 10:26:55 +0100

axe-demultiplexer (0.3.1-2) unstable; urgency=medium

  * Add autopkgtest

 -- Kevin Murray <spam@kdmurray.id.au>  Fri, 05 Feb 2016 20:27:46 +0100

axe-demultiplexer (0.3.1-1) unstable; urgency=medium

  * Imported Upstream version 0.3.1 (Closes: #808570)
  * Change arch to any, non 64 bit archs should work now

 -- Kevin Murray <spam@kdmurray.id.au>  Mon, 21 Dec 2015 14:31:47 +1100

axe-demultiplexer (0.3.0+dfsg-2) unstable; urgency=medium

  * Depend on GSL2 for the ongoing GSL transition (Closes: #807184)

 -- Kevin Murray <spam@kdmurray.id.au>  Mon, 07 Dec 2015 08:37:49 +1100

axe-demultiplexer (0.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release, refresh patches (Closes: #801900)
  * Split libqes to separate package
  * Restrict arch to amd64 & i386 (Closes: #801696)
  * Correct license details in d/copyright
  * Don't use bundled copy of GSL, build-dep on libgsl0-dev

 -- Kevin Murray <spam@kdmurray.id.au>  Tue, 01 Dec 2015 09:39:20 +1100

axe-demultiplexer (0.2.8-1) unstable; urgency=medium

  * Initial debian release. (Closes: #794088)

 -- Kevin Murray <spam@kdmurray.id.au>  Mon, 12 Oct 2015 16:54:45 +1100

=== debian/control ===
Source: axe-demultiplexer
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9),
               cmake,
               zlib1g-dev,
               libqes-dev,
               libgsl-dev,
               python-sphinx,
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/axe-demultiplexer.git
Vcs-Git: https://anonscm.debian.org/debian-med/axe-demultiplexer.git
Homepage: https://github.com/kdmurray91/axe

Package: axe-demultiplexer
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Trie-based DNA sequencing read demultiplexer
 Axe very rapidly selects the optimal barcode present in a sequence read, even
 in the presence of sequencing errors. The algorithm is able to handle
 combinatorial barcoding, barcodes of differing length, and several mismatches
 per barcode.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake --parallel

=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg.*//,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/axe-demultiplexer_$1.tar.gz/" \
  https://github.com/kdmurray91/axe/tags .*/v?(\d\S*)\.tar\.gz

## axe-demultiplexer 0.3.2+dfsg1

=== CMakeLists.txt ===
PROJECT(axe C)
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake-modules")

# Cmake options
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
ENABLE_TESTING()

IF (NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release)
ENDIF()

IF (NOT AXE_VERSION)
	# git describe as versioning
	EXECUTE_PROCESS(COMMAND git describe
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE AXE_VERSION
			OUTPUT_STRIP_TRAILING_WHITESPACE)
ENDIF()

MESSAGE(STATUS "${CMAKE_BUILD_TYPE} build of axe version: ${AXE_VERSION}")

###############################
## Find Packages and Headers ##
###############################

FIND_PACKAGE(ZLIB 1.2.5 REQUIRED)

FIND_PACKAGE(GSL)

IF (GSL_FOUND)
    SET(AXE_DEP_INCLUDES ${GSL_INCLUDE_DIRS})
    SET(AXE_DEP_LIBS ${GSL_LIBRARIES})
ENDIF()


##########################
## Set Compiler Options ##
##########################

# Set CFLAGS
SET(AXEWRN "${AXEWRN} -fstack-protector-all -Wstack-protector")
SET(AXEWRN "${AXEWRN} -Wall -Wextra -Wpedantic")

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${AXEWRN}")

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src
                    ${PROJECT_SOURCE_DIR}/src/datrie
                    ${PROJECT_SOURCE_DIR}/src/libqes/src
                    ${PROJECT_SOURCE_DIR}/src/gsl)
LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lib)

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/src/axe_config.h.in
               ${CMAKE_BINARY_DIR}/axe_config.h)

SET(LIBQES_AS_SUBMODULE True)  # stop libqes installing itself
ADD_SUBDIRECTORY(src/libqes)
ADD_SUBDIRECTORY(docs)
ADD_SUBDIRECTORY(tests)
ADD_SUBDIRECTORY(src)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/tinytest)
 
 ADD_EXECUTABLE(test_axe test.c ${CMAKE_CURRENT_SOURCE_DIR}/tinytest/tinytest.c test_libaxe.c)
-TARGET_LINK_LIBRARIES(test_axe ${AXE_DEPENDS_LIBRARIES} axelib)
+TARGET_LINK_LIBRARIES(test_axe ${AXE_DEPENDS_LIBRARIES} axelib qes_static)
 
 # Copy test files over to bin dir & make output
 ADD_CUSTOM_TARGET(setup_tests ALL

=== debian/changelog ===
axe-demultiplexer (0.3.2+dfsg1-1build1) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 00:08:12 +0000

axe-demultiplexer (0.3.2+dfsg1-1) unstable; urgency=medium

  [ Kevin Murray ]
  * New upstream version 0.3.2
  * Bump standards-version to 3.9.8
  * Update uploader email

  [ Andreas Tille ]
  * debhelper 10 (makes --parallel in d/rules superfluous)
  * d/watch: version=4
  * hardening=+all
  * Install test script also as user accessible test

 -- Kevin Murray <kdmfoss@gmail.com>  Thu, 01 Dec 2016 12:32:30 +1100

axe-demultiplexer (0.3.1-4) unstable; urgency=low

  [ Kevin Murray ]
  * Fix Vcs-git URL

  [ Mattia Rizzolo ]
  * debian/rules: drop useless include
  * debian/control: Bump Standards-Version to 3.9.7, no changes needed

 -- Kevin Murray <kdmfoss@gmail.com>  Wed, 02 Mar 2016 14:20:13 +1100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: axe-demultiplexer
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Kevin Murray <spam@kdmurray.id.au>
+Uploaders: Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 9),
+Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 10),
                cmake,
                zlib1g-dev,
                libqes-dev,
                libgsl-dev,
                python-sphinx,
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/axe-demultiplexer.git
-Vcs-Git: https://anonscm.debian.org/debian-med/axe-demultiplexer.git
+Vcs-Browser: https://anonscm.debian.org/git/debian-med/axe-demultiplexer.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/axe-demultiplexer.git
 Homepage: https://github.com/kdmurray91/axe
 
 Package: axe-demultiplexer

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')

%:
	dh $@ --buildsystem=cmake

override_dh_installdocs:
	dh_installdocs
	mkdir -p debian/$(DEBPKGNAME)/usr/share/doc/$(DEBPKGNAME)/tests
	cp -a tests/data debian/$(DEBPKGNAME)/usr/share/doc/$(DEBPKGNAME)/tests

## axe-demultiplexer 0.3.3+dfsg

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	COMMAND ${CMAKE_COMMAND} -E remove_directory "${CMAKE_BINARY_DIR}/doc"
         WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
         )
-    ADD_CUSTOM_TARGET(doc ALL DEPENDS doc_man doc_onehtml)
+    ADD_CUSTOM_TARGET(doc ALL DEPENDS doc_man doc_html doc_onehtml)
     INSTALL(FILES ${CMAKE_BINARY_DIR}/doc/man/axe.1 DESTINATION "share/man/man1" RENAME "axe-demux.1")
     SET_DIRECTORY_PROPERTIES(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES doc/)
 ELSE()

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = .build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/axe.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/axe.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/axe"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/axe"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== src/CMakeLists.txt ===
# Copyright 2014-2015 Kevin Murray <spam@kdmurray.id.au>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Axe library (libaxe.a)
FILE(GLOB DATRIE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/datrie/*.c)
FILE(GLOB GSL_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/gsl/*.c)
SET(AXELIB_SRCS ${DATRIE_SRCS} axe.c)

IF (NOT GSL_FOUND)
    MESSAGE(STATUS "Using bundled GSL sources")
    SET(AXELIB_SRCS ${AXELIB_SRCS} ${GSL_SRCS})
ENDIF()

ADD_LIBRARY(axelib STATIC ${AXELIB_SRCS})
TARGET_LINK_LIBRARIES(axelib qes_static ${AXE_DEP_LIBS})
SET_TARGET_PROPERTIES(axelib PROPERTIES OUTPUT_NAME axe)

# Executable
ADD_EXECUTABLE(axe-demux main.c)
TARGET_LINK_LIBRARIES(axe-demux ${AXE_DEPENDS_LIBS} axelib)
INSTALL(TARGETS axe-demux DESTINATION "bin")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -73,7 +73,7 @@
 
 		# Capturing lcov counters and generating report
 		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --directory ${CMAKE_BINARY_DIR}/src --capture --output-file ${COVERAGE_OUT}.info
-		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --output-file ${COVERAGE_OUT}.info --remove ${COVERAGE_OUT}.info src/kmlib/*
+		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --output-file ${COVERAGE_OUT}.info --remove ${COVERAGE_OUT}.info src/libqes/*
 		COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --output-file ${COVERAGE_OUT}.info --remove ${COVERAGE_OUT}.info src/datrie/*
 		COMMAND ${GENHTML_PATH} --branch-coverage -o ${COVERAGE_OUT} ${COVERAGE_OUT}.info
 		COMMAND ${CMAKE_COMMAND} -E remove ${COVERAGE_OUT}.info

=== debian/changelog ===
axe-demultiplexer (0.3.3+dfsg-5) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * Backport upstream fix for FTBFS with CMake 4. Closes: #1112715.

  [ Santiago Vila ]
  * d/control: Drop "Rules-Requires-Root: no" (default).
  * d/control: Update standards-version.
  * d/salsa-ci.yml: Use the simplified version.

 -- Santiago Vila <sanvila@debian.org>  Sun, 12 Oct 2025 13:20:00 +0200

axe-demultiplexer (0.3.3+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Fix clean target
    Closes: #1043648
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Fri, 26 Jan 2024 22:32:23 +0100

axe-demultiplexer (0.3.3+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.1 (routine-update)
  * Fix FTCBFS: Annotate python3-sphinx dependency :native.
    - Thank you, Helmut Grohne (Closes: #982608)

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 14 Feb 2021 21:04:35 +0530

axe-demultiplexer (0.3.3+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * rename debian/NEWS.Debian debian/NEWS (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Fri, 30 Oct 2020 11:36:34 +0100

axe-demultiplexer (0.3.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * debhelper 11
  * Build-Depends: s/python-sphinx/python3-sphinx/
  * Do not parse d/changelog
  * Enable running tests using Python3 instead of Python2

 -- Andreas Tille <tille@debian.org>  Thu, 26 Apr 2018 15:24:43 +0200

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Uploaders: Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                zlib1g-dev,
                libqes-dev,
                libgsl-dev,
-               python-sphinx,
-Vcs-Browser: https://anonscm.debian.org/git/debian-med/axe-demultiplexer.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/axe-demultiplexer.git
+               python3-sphinx:native
+Standards-Version: 4.7.2
+Vcs-Browser: https://salsa.debian.org/med-team/axe-demultiplexer
+Vcs-Git: https://salsa.debian.org/med-team/axe-demultiplexer.git
 Homepage: https://github.com/kdmurray91/axe
 
 Package: axe-demultiplexer

=== debian/tests/control ===
Tests: gbs
Restrictions: allow-stderr
